/*
 * Плагин jQuery.
 * Создает обработчики для каждой записи в таблице.
 */ 
(function($) {
	$.fn.todonote = function(options) {
		var settings = $.extend({
			stateDialogId: 'state_dialog'
			, removeDialogId: 'remove_dialog'
		}, options || {});
		var element = this;
		
		//обработчик hover эффекта - добавляет иконку "Удалить"
		element.hover(
			function() {
				$(this).find('.removeNote').addClass('removeIcon');
			}
			, function() {
				$(this).find('.removeNote').removeClass('removeIcon');
			}
		);
		
		/*
		 * Этот обработчик открывает диалог изменения статуса записи 
		 */
	    element.find('.note_state').click(function() {
			var selectedNote = $(this);
			//сохраняем текущую картинку и id записи
			$.todoStates.curImgTag = selectedNote;
			$.todoStates.prevImg = selectedNote.attr('src');
			$.todoStates.curId = selectedNote.parent().parent().attr('id').substr(5);
			//открываем диалоговое окно с вариантами состояний
	        $('#' + settings.stateDialogId).dialog('open');
	    });
		
		/*
		 * Этот обработчик открывает диалог удаления записи
		 */
        element.find('.removeNote').click(function(){
			var selectedNote = $(this).parent().parent();
			$('#' + settings.removeDialogId).dialog('open');
			$('#' + settings.removeDialogId).dialog('option', 'note', selectedNote);
        });
		
		/*
		 * Этот обработчик делает поле с текстом записи редактируемым
		 * (используется плагин jeditable)
		 */
		element.find('.note_text pre').click(function() {
			$(this).editable('http://' + window.location.host + '/main/updatetext'
				, {
					tooltip: 'Нажмите чтобы изменить...'
					, type: 'textarea'
					, cancel: 'Отмена'
					, submit: 'OK'
					, cssclass: 'editText'
					, indicator: '<img src="' + 'http://' + window.location.host + '/images/ajax-loader-small.gif" />'
					, onblur : 'ignore'
					, width: '100%'
					, height: '70px'
				});
		});
		
		/*
		 * Этот обработчик делает поле с датой редактируемым
		 * (используется плагин jeditable)
		 */
		element.find('.note_date').click(function() {
			$(this).editable('http://' + window.location.host + '/main/updatedate'
				, {
					tooltip: 'Нажмите чтобы изменить...'
					, indicator: '<img src="' + 'http://' + window.location.host + '/images/ajax-loader-small.gif" />'
					, type: 'calendar'
					, submit: 'OK'
					, cancel: 'Отмена'
					, onblur : 'ignore'
					, cssclass: 'editDate'
				});
		});

		return element;
	};
})(jQuery);