$(function() {
    //форма создания новой записи
    var noteDate = $('#notedate');
    var noteText = $('#notetext');
    
    var tips = $("#validateTips");
    
    var allFields = $([]).add(noteDate).add(noteText);

    //обновляем описание ошибки    
    function updateTips(t) {
        tips.text(t).effect("highlight",{},1500);
    }
    
    //проверяем количество символов, введенных в поле
    function checkLength(o,n,min,max) {
        if ( o.val().length > max || o.val().length < min ) {
            o.addClass('ui-state-error');
            updateTips("Количество символов в поле " + n + " должно быть от "+min+" до "+max+".");
            return false;
        } else {
            return true;
        }
    }
    
    //проверка с помощью регулярного выражения
    function checkRegexp(o,regexp,n) {
        if ( !( regexp.test( o.val() ) ) ) {
            o.addClass('ui-state-error');
            updateTips(n);
            return false;
        } else {
            return true;
        }
    }
	
    $('#dialog').dialog({
        bgiframe: true
        , autoOpen: false
        , height: 320
        , modal: true
        , buttons: {
            'Создать' : function() {
                //проверяем введенные данные
                var bValid = true;
                allFields.removeClass('ui-state-error');
                
				bValid = bValid && checkLength(noteText,"Text",1,20000);
				bValid = bValid && checkLength(noteDate,"Date",10,10);
				bValid = bValid && checkRegexp(noteDate,/\d{4}-\d{2}-\d{2}/,"Формат даты гггг-мм-дд");

                if (bValid) {
                    //создаём запись
                    $.post('http://' + window.location.host + '/main/addnote', {n_text:noteText.val(), n_date:noteDate.val()}, function(data) {
                        var reply = eval('(' + data + ')');
                        if (reply.status == 'OK') {
							//закрываем диалог
                            $('#dialog').dialog('close');
                            //вставляем новую запись
							//предварительно проверяем, существует ли таблица или выведено сообщение
							//об отсутствии записей
							if ($('h2').length > 0) {
								var table = $('<table id="noteslist"></table>');
								table.insertAfter($('h2'));
								$('h2').remove();
							}
							var newNote = $('<tr id="note_' + reply.id + '">'
											+ '<td><img class="note_state" alt="' + reply.state + '" src="' + reply.state_img_url + '" /></td>'
											+ '<td class="note_text"><pre id="note_text_' + reply.id + '">' + reply.text + '</pre></td>'
											+ '<td class="note_date" id="note_date_' + reply.id + '">' + reply.date + '</td>'
											+ '<td><div class="removeNote"></div></td>'
											+ '</tr>');
							//эффект работает т.к. выполняется параллельно prepend() и значительно дольше 
							newNote.todonote().effect('highlight', {color: 'green'}, 1000);
							newNote.insertAfter($('.table_header'));
                        }
                        else {
                            updateTips(reply.message);
                        }
                    });
                }
            }
            , 'Отмена' : function() {
                $(this).dialog('close');
            }
        }
        , close : function() {
            allFields.val('').removeClass('ui-state-error');
        }
    });
    
    //обработчик кнопки "Новая запись"
    $('#newnote > a').click(function() {
        $('#dialog').dialog('open');
		$('#notedate').datepicker({dateFormat: 'yy-mm-dd'});
        return false;
    });
});